#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_FishRankCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_FishRankCFG> Fish_FishRankCFG::msSingleton(nullptr);

int Fish_FishRankCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FishRankCFGData* Fish_FishRankCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_FishRankCFGData>& Fish_FishRankCFG::GetMapData()
{
	return mMapData;
}

void Fish_FishRankCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_FishRankCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FishRankCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRankName = element->Attribute("RankName");
		data.mIntegral = element->Attribute("Integral");
		data.mStars1 = element->Attribute("Stars1");
		data.mStars2 = element->Attribute("Stars2");
		data.mStars3 = element->Attribute("Stars3");
		{
			const char* RankRewardId = element->Attribute("RankRewardId");
			std::vector<std::string> vecRankRewardId;
			boost::split(vecRankRewardId, RankRewardId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRankRewardId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRankRewardId[i].c_str(), &temp))
				{
					data.mRankRewardId.push_back(temp);
				}
			}
		}
		{
			const char* RankRewardCount = element->Attribute("RankRewardCount");
			std::vector<std::string> vecRankRewardCount;
			boost::split(vecRankRewardCount, RankRewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRankRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRankRewardCount[i].c_str(), &temp))
				{
					data.mRankRewardCount.push_back(temp);
				}
			}
		}
		{
			const char* SeaGodRewardId = element->Attribute("SeaGodRewardId");
			std::vector<std::string> vecSeaGodRewardId;
			boost::split(vecSeaGodRewardId, SeaGodRewardId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecSeaGodRewardId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecSeaGodRewardId[i].c_str(), &temp))
				{
					data.mSeaGodRewardId.push_back(temp);
				}
			}
		}
		{
			const char* SeaGodRewardCount = element->Attribute("SeaGodRewardCount");
			std::vector<std::string> vecSeaGodRewardCount;
			boost::split(vecSeaGodRewardCount, SeaGodRewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecSeaGodRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecSeaGodRewardCount[i].c_str(), &temp))
				{
					data.mSeaGodRewardCount.push_back(temp);
				}
			}
		}
		data.mGiftId = element->IntAttribute("GiftId");
		data.mResources = element->Attribute("Resources");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_FishRankCFG::Load()
{
	Load("../Config/Fish_FishRankCFG.xml");
}

Fish_FishRankCFG* Fish_FishRankCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FishRankCFG());
	}
	return msSingleton.get();
}
